<?xml version="1.0" encoding="UTF-8" standalone="no"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

	<xsl:variable name="ShowTraceMessages" select="'false'"/>
	
	<xsl:template match="/">
		<xsl:apply-templates/>			
	</xsl:template>
	
	<xsl:template match="RCL_Log">
		<html>
			<body>
				<h1><center>RCL Log for Product "<xsl:value-of select="Product"/>&quot;&#160;Version &quot;<xsl:value-of select="Version"/>&quot;</center></h1>
				<br/>
				<h3><xsl:value-of select="TimeStamp"/></h3>
				<table border="1">
				<tr style="background-color:#6058F0">
					<th style="color:white"><b> TimeInMilliSeconds </b></th>
					<th style="color:white"><b> Event </b></th>
					<th style="color:white"><b> Source </b></th>
					<th style="color:white"><b> Id </b></th>
					<th style="color:white"><b> Severity </b></th>
					<th style="color:white"><b> Text </b></th>
					<th style="color:white"><b> Description </b></th>
					<th style="color:white"><b> UserAction </b></th>
				</tr>
				<xsl:for-each select="Record">
					<xsl:choose>
						<xsl:when test="Event='General'">
								<tr>
									<td></td>
									<td></td>
									<td><xsl:value-of select="Source"/></td>
									<td></td>
									<td></td>
									<td><xsl:value-of select="Text"/></td>
									<td><xsl:value-of select="Desc"/></td>
								</tr>			
						</xsl:when>	

						<xsl:when test="not(Severity) and $ShowTraceMessages='true'">
								<tr>
									<td></td>
									<td></td>
									<td><xsl:value-of select="Source"/></td>
									<td><xsl:value-of select="Thread_Id"/></td>
									<td></td>
									<td><xsl:value-of select="Text"/></td>
									<td><xsl:value-of select="Desc"/></td>
									<td><xsl:value-of select="UserAction"/></td>
								</tr>			
						</xsl:when>	

						<xsl:when test="Severity='Info'">
								<tr style="background-color:green">
									<td style="color:white"><b><xsl:value-of select="TimeInMS"/></b></td>
									<td style="color:white"><b><xsl:value-of select="Event"/></b></td>
									<td></td>
									<td style="color:white"><b><xsl:value-of select="Id"/></b></td>
									<td style="color:white"><b><xsl:value-of select="Severity"/></b></td>
									<td style="color:white"><b><xsl:value-of select="Text"/></b></td>
									<td style="color:white"><b><xsl:value-of select="Desc"/></b></td>
									<td style="color:white"><b><xsl:value-of select="UserAction"/></b></td>
								</tr>			
						</xsl:when>	

						<xsl:when test="Severity='Warning'">
								<tr style="background-color:yellow">
									<td style="color:#0030C0"><b><xsl:value-of select="TimeInMS"/></b></td>
									<td style="color:#0030C0"><b><xsl:value-of select="Event"/></b></td>
									<td></td>
									<td style="color:#0030C0"><b><xsl:value-of select="Id"/></b></td>
									<td style="color:#0030C0"><b><xsl:value-of select="Severity"/></b></td>
									<td style="color:#0030C0"><b><xsl:value-of select="Text"/></b></td>
									<td style="color:#0030C0"><b><xsl:value-of select="Desc"/></b></td>
									<td style="color:#0030C0"><b><xsl:value-of select="UserAction"/></b></td>
								</tr>			
						</xsl:when>	

						<xsl:when test="Severity='Error'">
								<tr style="background-color:#E00000">
									<td style="color:white"><b><xsl:value-of select="TimeInMS"/></b></td>
									<td style="color:white"><b><xsl:value-of select="Event"/></b></td>
									<td></td>
									<td style="color:white"><b><xsl:value-of select="Id"/></b></td>
									<td style="color:white"><b><xsl:value-of select="Severity"/></b></td>
									<td style="color:white"><b><xsl:value-of select="Text"/></b></td>
									<td style="color:white"><b><xsl:value-of select="Desc"/></b></td>
									<td style="color:white"><b><xsl:value-of select="UserAction"/></b></td>
								</tr>			
						</xsl:when>	
						
						<xsl:when test="Severity='Fatal'">
								<tr style="background-color:red" >
									<td style="color:white"><b><xsl:value-of select="TimeInMS"/></b></td>
									<td style="color:white"><b><xsl:value-of select="Event"/></b></td>
									<td></td>
									<td style="color:white"><b><xsl:value-of select="Id"/></b></td>
									<td style="color:white"><b><xsl:value-of select="Severity"/></b></td>
									<td style="color:white"><b><xsl:value-of select="Text"/></b></td>
									<td style="color:white"><b><xsl:value-of select="Desc"/></b></td>
									<td style="color:white"><b><xsl:value-of select="UserAction"/></b></td>
								</tr>			
						</xsl:when>	
					</xsl:choose>	
				</xsl:for-each>	
				</table>
			</body>
		</html>
	</xsl:template>
</xsl:stylesheet>
