//*************************************************************************************************************************************
// This file was automatically generated by the Rhapsody FMI plugin.
// Don't modify this file in any circumstances: it will be eventually overwritten without notice.
// Generated files with modifications are not supported!!!
//*************************************************************************************************************************************
#define CREATION_TIME "$(CreationTime)"
// define class name and unique id
#define MODEL_IDENTIFIER $(Model_Identifier)
#define MODEL_GUID "$(Model_GUID)"

#define MODEL_IDENTIFIER_STRING "$(Model_Identifier)"
#define _IS_WRAPPED $(WrappedBlock)


// dummy continuous variable
#define x0_     $(RealNum)
#define der_x0_ $(RealNum)+1

// add a dummy state for dummy continuous variable
#if $(CREATE_DUMMY_STATE)
#define NUMBER_OF_REALS $(RealNum)+2
#define NUMBER_OF_STATES 1

// define initial state vector as vector of value references
#define STATES { x0_ }

#else

#define NUMBER_OF_REALS $(RealNum)
#define NUMBER_OF_STATES 0

#endif

//define number of model variables
#define NUMBER_OF_INTEGERS $(IntNum)
#define NUMBER_OF_BOOLEANS $(BoolNum)
#define NUMBER_OF_STRINGS $(StringNum)

#define NUMBER_OF_EVENT_INDICATORS 0


#ifdef _MSC_VER
#  pragma warning( push )
#  pragma warning( disable: 4290 )
#  pragma warning( disable: 4018 )
#  pragma warning( disable: 4101 )
#endif

#include <windows.h>
   /* Rhapsody's Framework files */
#include <oxf/os.h>
#include <oxf/oxf.h>
#include <oxf/OMMainThread.h>
#include <oxf/omthread.h>
#include <oxf/OMTimerManager.h>
#include <oxf/OMSFunctionTimerFactory.h>
#include <oxf/OMSFunctionTimer.h>
//TODO: eliminate if we can
//#include <..\Profiles\SysML\SIDefinitions.h>
#include <oxf\omreactive.h>
#include <oxf\state.h>
#include <oxf\event.h>
#include <oxf\ommap.h>

#include "$(Class_Identifier).h"

// include fmu header files, typedefs and macros
extern "C" {
#include "fmuTemplate.h"
}
#define RHPModel $(Class_Identifier)

#define IS_DOUBLE(value) (mxIsNumeric(value) && !mxIsLogical(value) && !mxIsEmpty(value) &&\
		!mxIsSparse(value) && !mxIsComplex(value) && mxIsDouble(value))
		
static ModelInstance* this_comp = NULL;
static OMOSMutex* simGuard = OMOSFactory::instance()->createOMOSMutex();


// Rhapsody time resolution is 1e-3sec (1 millisecond). 
// FMI timestamps will be converted to nearest lower integer number of milliseconds within simulatedTimePrecision

const double simulatedTimePrecision = 1e-6; // in seconds

static void SFunctionNotifyEventCbk(void)
{
    ModelInstance* comp = this_comp;
	/* when we get notified from Rhapsody that an event has been put into 
		the event queue, we need to wait till Rhapsody is in idle */
	if(comp) comp->bShouldWait = true;
}
static void SFunctionNotifyIdleCbk(void)
{
    ModelInstance* comp = this_comp;
	/* when we are notified that rhapsody is in Idle we can free FMU simulator */
	if(comp && comp->bShouldWait) {
		if(comp) comp->bShouldWait = false;
		if(comp && comp->responseSignal) comp->responseSignal->signal();
		if(comp && comp->requestSignal) comp->requestSignal->wait(-1);
	}
}
static void checkAndWaitForIdle(ModelInstance* this_comp)
{
    ModelInstance* comp = this_comp;
	/* if the 'bShouldWait' flag is on we need to wait till Rhapsody notifies Idle */
	if(comp && comp->bShouldWait) {
		if(!comp->isThreadDispatching) {
			RHPModel * rhpModel=(RHPModel*) (comp->obj);
			OMThread* eventsThread= static_cast<OMThread*>(rhpModel->getActiveContext());
			comp->isThreadDispatching = true;
			eventsThread->startDispatching();
		}
		else
    		if(comp->requestSignal) comp->requestSignal->signal();
		if(comp->responseSignal) comp->responseSignal->wait(-1);
	}

//	if(this_comp && this_comp->requestSignal) {
//		comp->requestSignal->reset(); // Ignore exscessive idle callbacks
//	}
}		


#ifdef _OMINSTRUMENT
static OMOSMutex* animGuard = NULL;

static void RhapsodyThreadsStoppedCbk(void)
{
	if(animGuard)
			animGuard->lock();
}
void advanceRhapsodyTime(timeUnit time);
static void RhapsodyThreadsWorkingCbk(void)
{
	if(animGuard)
		animGuard->unlock();
}
#endif

/* getNextTimeout report next timeout event, returns 0 if no timeout events in queue */
unsigned long getNextTimeout()
{
	/* OMTimerManager::instance()->getNextTime() report next timeout event, returns current time if no timeout events in queue */
	unsigned long nextTO= OMTimerManager::instance()->getNextTime();
	if(nextTO==OMTimerManager::instance()->getElapsedTime())
		nextTO=0;
	return nextTO;
}


void advanceRhapsodyTime(timeUnit time)
{	
	/* apply the new time on Rhapsody's framework w/o processing timeout events */
	OMSFunctionTimerFactory* factory=OMSFunctionTimerFactory::instance();
	OMSFunctionTimer* pTimer = (OMSFunctionTimer*)factory->getCurrentTimer();
	if(pTimer != NULL) 
		pTimer->setSystemTime(time);
 }

//Block functions

// Called when simulation ends
void terminate(ModelInstance *comp)
{
	#ifdef _OMINSTRUMENT
		AOMSchedDispatcher* inst = AOMSchedDispatcher::getInstance();
		if(inst != NULL)
			inst->setTerminating();
		AnimServices::cleanup();
    #endif
}
// Free instance
void  freeInstance(ModelInstance *comp)
{
	if(this_comp == comp)
		this_comp = NULL;	

	RHPModel * rhpModel = (RHPModel*) (comp->obj);
#ifdef _OMINSTRUMENT
	AOMSchedDispatcher* inst = AOMSchedDispatcher::getInstance();
	if(inst != NULL)
		inst->setTerminating();
#endif
	if(comp) comp->bShouldWait = false;

	/* signal the requestSignal */
	if(comp && comp->requestSignal)
	{
		comp->requestSignal->signal();
	}
	/* signal the responseSignal */
	if(comp && comp->responseSignal)
	{
		comp->responseSignal->signal();
	}
	
#ifdef _OMINSTRUMENT
	/* cleanup animGuard */
	if(animGuard)
	{
		OMOSMutex *tmp = animGuard;
		animGuard = NULL;
		tmp->unlock();
		delete tmp;
	}
#endif
	OMThread* eventsThread = NULL;	
	if(rhpModel)
	{
		eventsThread = static_cast<OMThread*>(rhpModel->getActiveContext());
//		rhpModel->setActiveContext(NULL);
		delete rhpModel;
		comp->obj = NULL;

	}
	/* close all framework threads and cleanup */
	OXF::cleanup();
	/* cleanup the SFunction Timer factory */
	OMSFunctionTimerFactory::cleanup();
	if(eventsThread)
		delete eventsThread;
	/* cleanup the requestSignal */
	if(comp && comp->requestSignal)
	{
		OMOSEventFlag *tmp = comp->requestSignal;
		comp->requestSignal = NULL;
		delete tmp;
	}
	/* cleanup the responseSignal */
	if(comp && comp->responseSignal)
	{
		OMOSEventFlag *tmp = comp->responseSignal;
		comp->responseSignal = NULL;
		delete tmp;
	}
	
}

// Start Framework and block execution
bool startModel(ModelInstance *comp)
{
	RHPModel * rhpModel=(RHPModel*) (comp->obj);
	bool res = rhpModel->startBehavior();

	/* Start the Framework */
	OXF::start(true);
	return res;
}


//FMU functions

void setString(ModelInstance* comp, fmiString * ptrString, const char * strVal)
{
    char *string = (char*) ptrString[0];
if (string) comp->functions.freeMemory(string);
			ptrString[0] = (fmiString)comp->functions.allocateMemory(1+strlen(strVal), sizeof(char));
			string= (char*)ptrString[0];
            if (!string) {
                comp->state = modelError;
                comp->functions.logger(NULL, comp->instanceName, fmiError, "error", "setString: Out of memory.");
                exit(0);
            }
            strcpy(string, strVal);
}

// called by fmiInstantiateModel
// instantiate OXF and the block
// Settings used unless changed by fmiSetX before fmiInitialize
bool instModel(ModelInstance *comp) {
	if(simGuard) simGuard->lock();
	if(this_comp!=NULL)
	{
		comp->functions.logger(comp, comp->instanceName, fmiError, "log",
			"Multiple instantiations of %s(%s) Rhapsody FMU is not supported. Remove multiple instances and restart the simulator.", MODEL_IDENTIFIER_STRING, comp->instanceName);
		if(simGuard) simGuard->unlock();
		return true;
		
	}
	else
	{
		this_comp = comp;
	}
	comp->bShouldWait = false;
	comp->isThreadDispatching = false;
	comp->time = 0;
	/* Set the framework tickTimerFactory to be the OMSFunctionTimerFactory */
	OXF::setTheTickTimerFactory(OMSFunctionTimerFactory::instance());
	OMTimerManager::setAllowDestroy(false);
	comp->requestSignal = OMOSFactory::instance()->createOMOSEventFlag();
	comp->responseSignal = OMOSFactory::instance()->createOMOSEventFlag();
	OXF::setNotifyIdleCbk(SFunctionNotifyIdleCbk);
	OXF::setNotifyEventCbk(SFunctionNotifyEventCbk);
	
// code to handle animation	
#ifdef _OMINSTRUMENT
	/* create a 'stopSiganl, and set the notify threadsWorking/threadsStopped callbacks */
	if(animGuard!= NULL) {
		comp->functions.logger(comp, comp->instanceName, fmiError, "log",
			"Multiple instantiations of Rhapsody FMU with animation is not supported. For multiple instantiations rebuild w/o animation.");
		if(simGuard) simGuard->unlock();
		return false;
	}
	else
		animGuard = OMOSFactory::instance()->createOMOSMutex();
		
	AOMSchedDispatcher::setNotifyThreadsWorkingCbk(RhapsodyThreadsWorkingCbk);
	AOMSchedDispatcher::setNotifyThreadsStoppedCbk(RhapsodyThreadsStoppedCbk);
#endif

	/* Initialize the Rhapsody Framework */
	
#ifdef _OMINSTRUMENT
	if(!OXF::initialize(0, NULL, $(AnimationPortNumber)))
#else
	if(!OXF::initialize())
#endif	 
	{
		if(simGuard) simGuard->unlock();
		return false;
	}
	

	/* create block instance of main block */
	OMThread* activeThread = new  OMThread();
	activeThread->setDeletionAllowed(false);
	RHPModel* rhpModel = new RHPModel(activeThread);
	comp->obj=(void *)rhpModel;
// update FMU attributes
	$(GetRHPAttributes);
// update FMU outputs 
	$(GetRHPOutputs);
// update FMU inputs
	$(GetRHPInputs);


	if(simGuard) simGuard->unlock();
	return true;
}

#if _IS_WRAPPED
OMEvent* readEvent(std::stringstream &__the_stream) {
    std::string eventName;
    if(__the_stream.eof())
    	return NULL;
    std::getline(__the_stream, eventName, '(');
    if(__the_stream.eof())
    	return NULL;
// set FMU attributes
    if(false) {}
$(ReadRHPEvents);
    return NULL;
}
#endif _IS_WRAPPED

// called by fmiInitialize() after setting eventInfo to defaults
// Used to set the first time event 
bool initialize(ModelInstance* comp, fmiEventInfo* eventInfo) {
	//if(simGuard) simGuard->lock();
	this_comp = comp;
	RHPModel * rhpModel=(RHPModel*) (comp->obj);
	
    comp->bShouldWait = false;
	comp->startTime =  comp->time;
// set RHP attributes (all other setters are called from the following FMIEventUpdate)
	$(SetRHPAttributes);

	
	
// request event update to start the model	
	eventInfo->upcomingTimeEvent	=fmiTrue;
	eventInfo->nextEventTime		=comp->time;
	comp->modelStarted = false;
	
	return true;
}

// called by fmiEventUpdate() after setting eventInfo to defaults
// Used to set the next time event, if any.
void setTime(ModelInstance *comp,fmiReal time)
{
}

void completedIntegratorStepTrigger(ModelInstance *comp,fmiBoolean* callEventUpdate)
{
		RHPModel * rhpModel=(RHPModel*) (comp->obj);
		bool mightTriggerChangeEvent = false;
	
		
		unsigned long timeout = getNextTimeout();
		// there is a timeout and (either there was no timeout or new timeout is earlier)
		bool earlierTO= (timeout!=0 && (comp->nextTO==0 || timeout<comp->nextTO));
		//check if any input port was changed
	    mightTriggerChangeEvent = mightTriggerChangeEvent || ($(CheckInputsChange));


		if(mightTriggerChangeEvent || comp->bShouldWait|| earlierTO)
		{
			*callEventUpdate = fmiTrue;
		}
		else
		{
			*callEventUpdate = fmiFalse;
		}

}

bool eventUpdate(ModelInstance* comp, fmiEventInfo* eventInfo) {
	//if(simGuard) simGuard->lock();
	this_comp = comp;

	//printf("eventUpdate\n");
	RHPModel * rhpModel=(RHPModel*) (comp->obj);
#if _IS_WRAPPED
	rhpModel->resetOutPortStreams();
#endif
	// suspend eventThread before updating time and providing input
	unsigned long RHP_time=(unsigned long)(1000*((comp->time - comp->startTime)+simulatedTimePrecision));


#ifdef _OMINSTRUMENT
	/* in animation mode, block the FMU simulator thread until Rhapsody threads are working */
	if(animGuard) animGuard->lock();
	bool repeatAdnvanceTime=true;
	int adnvanceTimeRetry=0;
	int maxRetries= 10;
	while(adnvanceTimeRetry<=maxRetries)
	{
#endif

	advanceRhapsodyTime(RHP_time);

#ifdef _OMINSTRUMENT
		if(animGuard) animGuard->unlock();

		if(OMTimerManager::instance()->getElapsedTime()!=RHP_time)
		{
			Sleep(500);
			adnvanceTimeRetry++;
		}
		else
		{
			break;
		}
	}
	if (adnvanceTimeRetry> maxRetries)
	{
		comp->functions.logger(comp, comp->instanceName, fmiError, "log",
					"FMU failed to advance Rhapsody clock.");
		return false;
	}
#endif


	// set RHP inputs  ports
	$(SetRHPInputs);
	if(!comp->modelStarted)
	{
		if(!startModel(comp))
		{
			comp->functions.logger(comp, comp->instanceName, fmiError, "log","");
			return false;
		}
		comp->modelStarted = true;
	}

// resume eventThread to process new time and inputs
// process all RHP events till simulation time

/* wait till Rhapsody finishes processing all events */
	checkAndWaitForIdle(comp);

// update FMU internal variables
	$(GetRHPAttributes);
// update FMU outputs 
	$(GetRHPOutputs);
	unsigned long nextTO = getNextTimeout();
#if _IS_WRAPPED
    if(rhpModel -> checkOutPortStreams())
	{
		eventInfo->upcomingTimeEvent   = fmiTrue;
		eventInfo->nextEventTime       =comp->time;
	}
	else
	{
#endif 
	
	if(nextTO==0)
	{
			eventInfo->upcomingTimeEvent   = fmiFalse;
	}
	else
	{
		eventInfo->upcomingTimeEvent = fmiTrue;
		double nextEventTime = ((double)nextTO)/1000 + comp->startTime;//1 + comp->time;
		eventInfo->nextEventTime = (comp->time > nextEventTime) ? comp->time : nextEventTime;
	}
#if _IS_WRAPPED
	}
#endif
	comp->nextTO=nextTO;

	//if(simGuard) simGuard->unlock();

	return true;
} 

fmiReal getReal(ModelInstance* comp, fmiValueReference vr){
	RHPModel * rhpModel=(RHPModel*) (comp->obj);
	if (vr==der_x0_)
		return 1;
	else
		return   r(vr);
}

// include code that implements the FMI based on the above definitions
extern "C" {
#include "fmuTemplate.c"
} // extern "C"


#ifdef _MSC_VER
#  pragma warning( pop )
#endif
