%
% MATLAB script for Rhapsody Parametric Constraints Evaluator
% xpceMATLAB.m
%
% (C) Copyright IBM Corp. 2010. All rights reserved.
%

xpceepsilon = 1e-8;
xpcebooleanp = @(x) isa(x,'sym') || isa(x,'logical');
xpcecomplexp = @(x) isa(x,'sym') || ~isa(x,'logical');
xpcerealp = @(x) isa(x,'sym') || ~isa(x,'logical') && isreal(x);
xpceintegerp = @(x) isa(x,'sym') || ~isa(x,'logical') && isreal(x) && ((x-floor(x)<=xpceepsilon) || (ceil(x)-x<=xpceepsilon));

javaaddpath('pcenet.jar');

xpceServer = com.ibm.rhapsody.pce.net.Server();
xpceServer.initializeServer();

xpceTimer=timer('TimerFcn','xpceMATLABexecute','ExecutionMode','fixedSpacing');
start(xpceTimer);