// Licensed Materials - Property of IBM
// (c) Copyright IBM Corporation 2009. All Rights Reserved.

#ifndef SIDefinitions_H 

#define SIDefinitions_H 

#include <oxf/oxf.h>

#ifdef ActionLanguage
#include "Primitives.h"
#endif

//## package StandardValueTypes 

//----------------------------------------------------------------------------
// SIDefinitions.h                                                                  
//----------------------------------------------------------------------------


//#[ ignore 
#ifndef ActionLanguage
typedef RhpReal Real;
#endif

struct Complex {
    Real imaginaryPart;		//## attribute imaginaryPart 
    Real realPart;		//## attribute realPart 
};
//#]


//## package SIDefinitions::BaseSIUnits 

//----------------------------------------------------------------------------
// SIDefinitions.h                                                                  
//----------------------------------------------------------------------------


//#[ ignore 
typedef Real AmountOfSubstance;

typedef Real ElectricCurrent;

typedef Real Length;

typedef Real LuminousIntensity;

typedef Real Mass;

typedef Real ThermodynamicTemperature;

typedef Real Time;

typedef ElectricCurrent Ampere;

typedef LuminousIntensity Candela;

typedef ThermodynamicTemperature Kelvin;

typedef Mass Kilogram;

typedef Length Meter;

typedef AmountOfSubstance Mole;

typedef Time Second;
//#]


//## package SIDefinitions::DerivedSIUnits 

//----------------------------------------------------------------------------
// SIDefinitions.h                                                                  
//----------------------------------------------------------------------------


//#[ ignore 
typedef Real Area;

typedef Real Volume;

typedef Real Velocity;

typedef Real Acceleration;

typedef Real WaveNumber;

typedef Real MassDensity;

typedef Real SpecificVolume;

typedef Real CurrentDensity;

typedef Real MagneticFieldStrength;

typedef Real AmountOfSubstanceConcentration;

typedef Real Luminace;

typedef Real Force;

typedef Real Energy;

typedef Real Power;

typedef Real ElectricCharge;

typedef Real ElectricVoltage;

typedef Real ElectricResistance;

typedef Real Pressure;

typedef Area SquareMeter;

typedef Volume CubicMeter;

typedef Velocity MeterPerSecond;

typedef Acceleration MeterPerSecondSquared;

typedef Luminace CandelaPerSquareMeter;

typedef WaveNumber ReciprocalMeter;

typedef CurrentDensity AmperePerSquareMeter;

typedef MassDensity KilogramPerCubicMeter;

typedef MagneticFieldStrength AmperePerMeter;

typedef SpecificVolume CubicMeterPerKilogram;

typedef AmountOfSubstanceConcentration MolePerCubicMeter;

typedef Force Newton;

typedef Energy Joule;

typedef Power Watt;

typedef ElectricCharge Coulomb;

typedef ElectricVoltage Volt;

typedef ElectricResistance Ohm;

typedef Pressure Pascal;
//#]

class StubInterfaceBlock {};


#endif  
/*********************************************************************
	File Path	: DefaultComponent\DefaultConfig\SIDefinitions.h
*********************************************************************/

